<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: /workplace/avs-device-sdk/AVSCommon/Utils/src/UUIDGeneration.cpp File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_13e65effb2bde530b17b3d5eefcd0266.html">AVSCommon</a></li><li class="navelem"><a class="el" href="dir_49dd3d9ac5586189aa170bac46425b9c.html">Utils</a></li><li class="navelem"><a class="el" href="dir_93a54634d0ab52618b36b15672961616.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#namespaces">Namespaces</a> &#124;
<a href="#define-members">Macros</a> &#124;
<a href="#func-members">Functions</a> &#124;
<a href="#var-members">Variables</a>  </div>
  <div class="headertitle">
<div class="title">UUIDGeneration.cpp File Reference</div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><code>#include &lt;random&gt;</code><br />
<code>#include &lt;chrono&gt;</code><br />
<code>#include &lt;sstream&gt;</code><br />
<code>#include &lt;iomanip&gt;</code><br />
<code>#include &lt;mutex&gt;</code><br />
<code>#include &lt;climits&gt;</code><br />
<code>#include &lt;algorithm&gt;</code><br />
<code>#include &lt;functional&gt;</code><br />
<code>#include &quot;<a class="el" href="_logger_8h_source.html">AVSCommon/Utils/Logger/Logger.h</a>&quot;</code><br />
<code>#include &quot;<a class="el" href="_u_u_i_d_generation_8h_source.html">AVSCommon/Utils/UUIDGeneration/UUIDGeneration.h</a>&quot;</code><br />
</div><div class="textblock"><div class="dynheader">
Include dependency graph for UUIDGeneration.cpp:</div>
<div class="dyncontent">
<div class="center"><img src="_u_u_i_d_generation_8cpp__incl.png" border="0" usemap="#_2workplace_2avs-device-sdk_2_a_v_s_common_2_utils_2src_2_u_u_i_d_generation_8cpp" alt=""/></div>
<map name="_2workplace_2avs-device-sdk_2_a_v_s_common_2_utils_2src_2_u_u_i_d_generation_8cpp" id="_2workplace_2avs-device-sdk_2_a_v_s_common_2_utils_2src_2_u_u_i_d_generation_8cpp">
<area shape="rect" id="node10" href="_logger_8h.html" title="AVSCommon/Utils/Logger\l/Logger.h" alt="" coords="653,105,829,144"/>
<area shape="rect" id="node27" href="_u_u_i_d_generation_8h.html" title="AVSCommon/Utils/UUIDGeneration\l/UUIDGeneration.h" alt="" coords="1351,192,1584,231"/>
<area shape="rect" id="node13" href="_configuration_node_8h.html" title="AVSCommon/Utils/Configuration\l/ConfigurationNode.h" alt="" coords="405,192,619,231"/>
<area shape="rect" id="node19" href="_level_8h.html" title="AVSCommon/Utils/Logger\l/Level.h" alt="" coords="789,279,965,317"/>
<area shape="rect" id="node20" href="_log_entry_8h.html" title="AVSCommon/Utils/Logger\l/LogEntry.h" alt="" coords="915,192,1091,231"/>
<area shape="rect" id="node25" href="_log_level_observer_interface_8h.html" title="AVSCommon/Utils/Logger\l/LogLevelObserverInterface.h" alt="" coords="643,192,840,231"/>
<area shape="rect" id="node26" href="_sink_observer_interface_8h.html" title="AVSCommon/Utils/Logger\l/SinkObserverInterface.h" alt="" coords="1240,365,1416,404"/>
<area shape="rect" id="node21" href="_log_entry_stream_8h.html" title="AVSCommon/Utils/Logger\l/LogEntryStream.h" alt="" coords="1040,279,1216,317"/>
<area shape="rect" id="node23" href="_log_entry_buffer_8h.html" title="AVSCommon/Utils/Logger\l/LogEntryBuffer.h" alt="" coords="928,365,1104,404"/>
</map>
</div>
</div><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="namespaces"></a>
Namespaces</h2></td></tr>
<tr class="memitem:namespacealexa_client_s_d_k"><td class="memItemLeft" align="right" valign="top"> &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></td></tr>
<tr class="memdesc:namespacealexa_client_s_d_k"><td class="mdescLeft">&#160;</td><td class="mdescRight">Whether or not curl logs should be emitted. <br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:namespacealexa_client_s_d_k_1_1avs_common"><td class="memItemLeft" align="right" valign="top"> &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common.html">alexaClientSDK::avsCommon</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:namespacealexa_client_s_d_k_1_1avs_common_1_1utils"><td class="memItemLeft" align="right" valign="top"> &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils.html">alexaClientSDK::avsCommon::utils</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1uuid_generation"><td class="memItemLeft" align="right" valign="top"> &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1uuid_generation.html">alexaClientSDK::avsCommon::utils::uuidGeneration</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="define-members"></a>
Macros</h2></td></tr>
<tr class="memitem:ad8bc9ca8e55a0ebf538e46e28bf26262"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="_u_u_i_d_generation_8cpp.html#ad8bc9ca8e55a0ebf538e46e28bf26262">LX</a>(event)&#160;&#160;&#160;<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1logger_1_1_log_entry.html">alexaClientSDK::avsCommon::utils::logger::LogEntry</a>(<a class="el" href="_u_i_manager_8cpp.html#ada5473a95becdcf63a8f83e7f05fefe7">TAG</a>, event)</td></tr>
<tr class="separator:ad8bc9ca8e55a0ebf538e46e28bf26262"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:abdc224f2660003085b6fd08e625fee1d"><td class="memItemLeft" align="right" valign="top">static const std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1uuid_generation.html#abdc224f2660003085b6fd08e625fee1d">alexaClientSDK::avsCommon::utils::uuidGeneration::TAG</a> (&quot;UUIDGeneration&quot;)</td></tr>
<tr class="memdesc:abdc224f2660003085b6fd08e625fee1d"><td class="mdescLeft">&#160;</td><td class="mdescRight">String to identify log entries originating from this file.  <a href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1uuid_generation.html#abdc224f2660003085b6fd08e625fee1d">More...</a><br /></td></tr>
<tr class="separator:abdc224f2660003085b6fd08e625fee1d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7cf01fbb04b393956de3adac97e95db0"><td class="memItemLeft" align="right" valign="top">static const std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1uuid_generation.html#a7cf01fbb04b393956de3adac97e95db0">alexaClientSDK::avsCommon::utils::uuidGeneration::SEPARATOR</a> (&quot;-&quot;)</td></tr>
<tr class="memdesc:a7cf01fbb04b393956de3adac97e95db0"><td class="mdescLeft">&#160;</td><td class="mdescRight">Separator used between UUID fields.  <a href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1uuid_generation.html#a7cf01fbb04b393956de3adac97e95db0">More...</a><br /></td></tr>
<tr class="separator:a7cf01fbb04b393956de3adac97e95db0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adaa2765261f2c0ca4015a98ef1175bfb"><td class="memItemLeft" align="right" valign="top">static const std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1uuid_generation.html#adaa2765261f2c0ca4015a98ef1175bfb">alexaClientSDK::avsCommon::utils::uuidGeneration::generateHexWithReplacement</a> (std::independent_bits_engine&lt; std::default_random_engine, CHAR_BIT, uint8_t &gt; &amp;ibe, unsigned int numDigits, uint8_t replacementBits, unsigned short numReplacementBits)</td></tr>
<tr class="separator:adaa2765261f2c0ca4015a98ef1175bfb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0073490cfe8c4218bdbc4cb85479e55e"><td class="memItemLeft" align="right" valign="top">static const std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1uuid_generation.html#a0073490cfe8c4218bdbc4cb85479e55e">alexaClientSDK::avsCommon::utils::uuidGeneration::generateHex</a> (std::independent_bits_engine&lt; std::default_random_engine, CHAR_BIT, uint8_t &gt; &amp;ibe, unsigned int numDigits)</td></tr>
<tr class="separator:a0073490cfe8c4218bdbc4cb85479e55e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af711859eff60cad465f1d0aa6909cbed"><td class="memItemLeft" align="right" valign="top">const std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1uuid_generation.html#af711859eff60cad465f1d0aa6909cbed">alexaClientSDK::avsCommon::utils::uuidGeneration::generateUUID</a> ()</td></tr>
<tr class="separator:af711859eff60cad465f1d0aa6909cbed"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="var-members"></a>
Variables</h2></td></tr>
<tr class="memitem:aad8db59e8283da913305f58c8cae2aa4"><td class="memItemLeft" align="right" valign="top">static const uint8_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1uuid_generation.html#aad8db59e8283da913305f58c8cae2aa4">alexaClientSDK::avsCommon::utils::uuidGeneration::UUID_VERSION_VALUE</a> = 4 &lt;&lt; 4</td></tr>
<tr class="memdesc:aad8db59e8283da913305f58c8cae2aa4"><td class="mdescLeft">&#160;</td><td class="mdescRight">The UUID version (Version 4), shifted into the correct position in the byte.  <a href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1uuid_generation.html#aad8db59e8283da913305f58c8cae2aa4">More...</a><br /></td></tr>
<tr class="separator:aad8db59e8283da913305f58c8cae2aa4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac71faa6b38e47b6d3146bfbe2c9dc6b2"><td class="memItemLeft" align="right" valign="top">static const size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1uuid_generation.html#ac71faa6b38e47b6d3146bfbe2c9dc6b2">alexaClientSDK::avsCommon::utils::uuidGeneration::UUID_VARIANT_VALUE</a> = 2 &lt;&lt; 6</td></tr>
<tr class="memdesc:ac71faa6b38e47b6d3146bfbe2c9dc6b2"><td class="mdescLeft">&#160;</td><td class="mdescRight">The UUID variant (Variant 1), shifted into the correct position in the byte.  <a href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1uuid_generation.html#ac71faa6b38e47b6d3146bfbe2c9dc6b2">More...</a><br /></td></tr>
<tr class="separator:ac71faa6b38e47b6d3146bfbe2c9dc6b2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a83ca8d43233bcf8200a42016cce8d40e"><td class="memItemLeft" align="right" valign="top">static const size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1uuid_generation.html#a83ca8d43233bcf8200a42016cce8d40e">alexaClientSDK::avsCommon::utils::uuidGeneration::MAX_NUM_REPLACEMENT_BITS</a> = CHAR_BIT</td></tr>
<tr class="memdesc:a83ca8d43233bcf8200a42016cce8d40e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Number of bits in the replacement value.  <a href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1uuid_generation.html#a83ca8d43233bcf8200a42016cce8d40e">More...</a><br /></td></tr>
<tr class="separator:a83ca8d43233bcf8200a42016cce8d40e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a84d0af91d9812874964b1cbc82e22e93"><td class="memItemLeft" align="right" valign="top">static const size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1uuid_generation.html#a84d0af91d9812874964b1cbc82e22e93">alexaClientSDK::avsCommon::utils::uuidGeneration::BITS_IN_HEX_DIGIT</a> = 4</td></tr>
<tr class="memdesc:a84d0af91d9812874964b1cbc82e22e93"><td class="mdescLeft">&#160;</td><td class="mdescRight">Number of bits in a hex digit.  <a href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1uuid_generation.html#a84d0af91d9812874964b1cbc82e22e93">More...</a><br /></td></tr>
<tr class="separator:a84d0af91d9812874964b1cbc82e22e93"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Macro Definition Documentation</h2>
<a id="ad8bc9ca8e55a0ebf538e46e28bf26262"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad8bc9ca8e55a0ebf538e46e28bf26262">&#9670;&nbsp;</a></span>LX</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define LX</td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">event</td><td>)</td>
          <td>&#160;&#160;&#160;<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1logger_1_1_log_entry.html">alexaClientSDK::avsCommon::utils::logger::LogEntry</a>(<a class="el" href="_u_i_manager_8cpp.html#ada5473a95becdcf63a8f83e7f05fefe7">TAG</a>, event)</td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Create a LogEntry using this file's TAG and the specified event string.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">The</td><td>event string for this <code>LogEntry</code>. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
</div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
